# Fast DDS Roadmap

This section elaborates on proposed new features or tasks which are expected to be added to the product in the foreseeable future.
There should be no assumption of a commitment to deliver these features on specific dates or in the order given.
The development team will be doing their best to follow the proposed dates and priorities, but please bear in mind that plans to work on a given feature or task may be revised.
All information is provided as a general guidelines only, and this section may be revised to provide newer information at any time.

Disclaimer:

* This section has been last updated in March 2024.
  Please take into account its content could be obsolete.

## Short term

The following list of features are planned to be addressed in the short term, and incorporated into the following release of the product (v3.0.0):

* DDS-XTypes 1.3
* Ignore local endpoints configured at endpoint level
* Complete support for dynamic network interfaces
* Use a gather-send approach to send data through the transports

## Medium term

The following list of features are planned to be addressed in the medium term, typically within the subsequent release(s) generated in the next **9 months** after next planned release:

* Tier 1 support for QNX platforms
* Tier 1 support for Android platforms
* Support for Time-based filter QoS
* Service aware DataWriter

## Long term

The following list of features are proposals regarding the longer-term evolution of the product even though development of these features has not yet been scheduled for a release in the near future.
Please feel free to contact us if you wish to get involved in the implementation or influence the roadmap.

* Full DDS API compliance
* Compliance with DDS-XML
* Low bandwidth transports
