// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Data64kb.cpp
 * This source file contains the implementation of the described types in the IDL file.
 *
 * This file was generated by the tool fastddsgen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Data64kb.h"

#if FASTCDR_VERSION_MAJOR == 1

#include <fastcdr/Cdr.h>


#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

namespace helper { namespace internal {

enum class Size {
    UInt8,
    UInt16,
    UInt32,
    UInt64,
};

constexpr Size get_size(int s) {
    return (s <= 8 ) ? Size::UInt8:
           (s <= 16) ? Size::UInt16:
           (s <= 32) ? Size::UInt32: Size::UInt64;
}

template<Size s>
struct FindTypeH;

template<>
struct FindTypeH<Size::UInt8> {
    using type = std::uint8_t;
};

template<>
struct FindTypeH<Size::UInt16> {
    using type = std::uint16_t;
};

template<>
struct FindTypeH<Size::UInt32> {
    using type = std::uint32_t;
};

template<>
struct FindTypeH<Size::UInt64> {
    using type = std::uint64_t;
};
}

template<int S>
struct FindType {
    using type = typename internal::FindTypeH<internal::get_size(S)>::type;
};
}

#define Data64kb_max_cdr_typesize 64004ULL;






Data64kb::Data64kb()
{
    // sequence<octet, 63996> m_data


}

Data64kb::~Data64kb()
{
}

Data64kb::Data64kb(
        const Data64kb& x)
{
    m_data = x.m_data;

}

Data64kb::Data64kb(
        Data64kb&& x) noexcept
{
    m_data = std::move(x.m_data);

}

Data64kb& Data64kb::operator =(
        const Data64kb& x)
{
    m_data = x.m_data;

    return *this;
}

Data64kb& Data64kb::operator =(
        Data64kb&& x) noexcept
{
    m_data = std::move(x.m_data);

    return *this;
}

bool Data64kb::operator ==(
        const Data64kb& x) const
{
    return (m_data == x.m_data);
}

bool Data64kb::operator !=(
        const Data64kb& x) const
{
    return !(*this == x);
}

size_t Data64kb::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return Data64kb_max_cdr_typesize;
}

size_t Data64kb::getCdrSerializedSize(
        const Data64kb& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.data().size() > 0)
    {
        current_alignment += (data.data().size() * 1) + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);
    }




    return current_alignment - initial_alignment;
}


void Data64kb::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{
    scdr << m_data;


}

void Data64kb::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{
    dcdr >> m_data;


}


bool Data64kb::isKeyDefined()
{
    return false;
}

void Data64kb::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}

/*!
 * @brief This function copies the value in member data
 * @param _data New value to be copied in member data
 */
void Data64kb::data(
        const std::vector<uint8_t>& _data)
{
    m_data = _data;
}

/*!
 * @brief This function moves the value in member data
 * @param _data New value to be moved in member data
 */
void Data64kb::data(
        std::vector<uint8_t>&& _data)
{
    m_data = std::move(_data);
}

/*!
 * @brief This function returns a constant reference to member data
 * @return Constant reference to member data
 */
const std::vector<uint8_t>& Data64kb::data() const
{
    return m_data;
}

/*!
 * @brief This function returns a reference to member data
 * @return Reference to member data
 */
std::vector<uint8_t>& Data64kb::data()
{
    return m_data;
}




#endif // FASTCDR_VERSION_MAJOR == 1
